package jigcell.project;

import java.util.*;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.table.AbstractTableModel;
import java.awt.Dimension;
import java.awt.GridLayout;


// no exception in the add and setProject


class GroupTable extends AbstractTableModel {

	private ProjectManager manager = null;
	private Project current = null;
	// for the table selections	
	public ProjectFile selectedModel = null, selectedRun = null, selectedExperiment = null,
			selectedFunctions = null, selectedPEData = null;
	private ArrayList fileList = null;

	public int getColumnCount() {
		return 3;
	}

	public int getRowCount() {
		try { return fileList.size(); } catch (Exception e) {e.printStackTrace(System.err); return 0; }
	}

	public String getColumnName(int col) {
		if (col == 0) return "File Name";
		else if (col == 1) return "Type";
		else return "Last Modified";
	} 

	public Object getValueAt(int row, int col) { 
		try {
			ProjectFile selected = (ProjectFile)fileList.get(row);
			int version = selected.getVersion();
			if (col == 0) return selected.getName();
			else if (col == 1) return selected.getMIMEType(version);
			else return selected.getModificationDate(version);
		} catch (Exception e) {e.printStackTrace(System.err); return null; }
	}

	public Class getColumnClass(int c) {
		return getValueAt(0, c).getClass();
	}

	public boolean isCellEditable(int row, int col) {
		return false;
	}

	public ProjectManager getProjectManager() {
		return manager;
	}

	public void setProjectManager(ProjectManager manager) {
		this.manager = manager;
	}

	public Project getProject() {
		return current;
	}

	public void setProject(Project current) {
		this.current = current;
		try { fileList = new ArrayList(current.getProjectFiles()); }  catch (Exception e) {e.printStackTrace(System.err);}
	}

	public void addFile(ProjectFile newFile) {
		// find the last file of this mime type, and add it in there
		try {
			int pos = 0;
			boolean found = false;
			while (pos < fileList.size()) {
				int version = ((ProjectFile)fileList.get(pos)).getVersion();
				ProjectFile current = (ProjectFile)fileList.get(pos);
				if (current.getMIMEType(version).compareTo(newFile.getMIMEType(newFile.getVersion())) == 0 && !found) found = true;
				else if (current.getMIMEType(version).compareTo(newFile.getMIMEType(newFile.getVersion())) != 0 && found) break;
				pos++;
			}
			// insert the item at position pos
			fileList.add(pos, newFile);
			// fire the appropriate things to show the data changed
			fireTableStructureChanged();
			
		}  catch (Exception e) {e.printStackTrace(System.err);}
	}

	public ProjectFile getFileAt(int row) {
		if (row > fileList.size()) return null;
		else return (ProjectFile)fileList.get(row);
	}
}
