package jigcell.project;

import java.util.*;
import javax.swing.tree.*;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;


// ??? we should work with the metadata from the files, not have the stuff as hard-coded as now
// ??? when we insert files it should be in the tree which later on puts them in the project file

class GroupTree implements TreeSelectionListener {
	private DefaultTreeModel treeModel = null;				// the tree model
	private DefaultMutableTreeNode root  = new DefaultMutableTreeNode();	// the root node of the tree
	private DefaultMutableTreeNode models = null, runs = null, experiments = null,
			functions = null, peData = null; // other nodes we can keep track of
	// for the tree selections	
	public ProjectFile selectedModel = null, selectedRun = null, selectedExperiment = null,
			selectedFunctions = null, selectedPEData = null;
	private javax.swing.JTree tree;

	private ProjectManager manager = null;

	public GroupTree(String rootName) {
		root.setUserObject(rootName);
		treeModel = new DefaultTreeModel(root);
		// biscuitii au schimbat iar functiile

		models = new DefaultMutableTreeNode("Models");
		runs = new DefaultMutableTreeNode("Runs");
		experiments = new DefaultMutableTreeNode("Experiments");
		functions = new DefaultMutableTreeNode("Objective Functions");
		peData = new DefaultMutableTreeNode("Parameter Estimator Data");
		root.add(models); root.add(runs); root.add(experiments); root.add(functions); root.add(peData);
	}

	public DefaultTreeModel getTreeModel(){return treeModel;}

	public void setTree(javax.swing.JTree tree) {
		this.tree = tree;
	}

	public javax.swing.JTree getTree() {
		return tree;
	}

	public void newModel(){
		DefaultMutableTreeNode newNode = new DefaultMutableTreeNode();
		// ProjectFile m = new ProjectFile();
		// addRunSet(m,newNode);
		// this.getTreeSelectionModel().setSelectionPath(new TreePath(m.getModelNode().getPath()));
	}

	private void addModel(ProjectFile m, DefaultMutableTreeNode newNode){
		newNode.setUserObject(m);
		models.add(newNode);
		treeModel.nodeStructureChanged(root);
		treeModel.nodeStructureChanged(models);
		treeModel.nodeStructureChanged(newNode);
	}

	public void addModel(ProjectFile m){
		DefaultMutableTreeNode carry = new DefaultMutableTreeNode();
		addModel(m, carry);
	}

	public ProjectFile[] getModels(){
		Vector v = new Vector();
		Enumeration e = models.depthFirstEnumeration();
		while(e.hasMoreElements()){
			Object o = e.nextElement();
			if(o instanceof DefaultMutableTreeNode){
				DefaultMutableTreeNode t = (DefaultMutableTreeNode)o;
				if(t.getUserObject() instanceof ProjectFile)
				v.add(t.getUserObject());
			}
		}
		ProjectFile [] set = new ProjectFile[v.size()];
		v.copyInto(set);
		return set;
	}

	/*
	private DefaultMutableTreeNode getSelectedModelNode(){
		TreeNode t = null;
		if(treeSelectionModel.getSelectionPath() != null && treeSelectionModel.getSelectionPath().getPathCount()>1)
			t = ((TreeNode)treeSelectionModel.getSelectionPath().getPathComponent(1));
		else return null;
		if(t instanceof DefaultMutableTreeNode){
			DefaultMutableTreeNode t1 = (DefaultMutableTreeNode)t;
			if(t1.getUserObject() instanceof ProjectFile)
				return t1;
			else {
				System.out.println("We did not find a model node");
				return null;
			}
		} else return null;
	}

	public ProjectFile getSelectedModel(){
		DefaultMutableTreeNode tmp = null;
		if((tmp = getSelectedModelNode()) != null) {
			System.out.println("Found selected model");
			ProjectFile temp = (ProjectFile)tmp.getUserObject();
			try {System.out.println(temp.getName());} catch (Exception e) {}
			return (ProjectFile)tmp.getUserObject();
		}
		else
			return null;
	}   

	public int getNumDescendants(){
		DefaultMutableTreeNode m = null;
		if(treeSelectionModel.getSelectionPath() != null)
			m = (DefaultMutableTreeNode)treeSelectionModel.getSelectionPath().getLastPathComponent();
		else return 0;

		Enumeration e = m.postorderEnumeration();
		int count = 0;
		while(e.hasMoreElements()){
			DefaultMutableTreeNode et = (DefaultMutableTreeNode)e.nextElement();
			if(et.getUserObject() instanceof ProjectFile) count++;
		}
		return count;
	}
	*/
	public ProjectManager getProjectManager() {
		return manager;
	}

	public void setProjectManager(ProjectManager manager) {
		this.manager = manager;
	}

	public void valueChanged(javax.swing.event.TreeSelectionEvent e){
		System.out.println("Selecting in tree");
		DefaultMutableTreeNode node = (DefaultMutableTreeNode) tree.getLastSelectedPathComponent();
		if(manager==null || node == null) return;
		Object nodeInfo = node.getUserObject();
		if (node.isLeaf() && nodeInfo instanceof ProjectFile) {
			// if(selectedModel != getSelectedModel()) selectedModel = getSelectedModel();
			selectedModel = (ProjectFile) nodeInfo;
			if (selectedModel == null) System.out.println("Wrong - is null");
		}
	}
}
