package jigcell.project;

import javax.swing.*;
import java.util.*;
import java.awt.*;
import java.io.*;

// check for creating a new project with the same name as something already existing

public class ProjectChooser extends JDialog {
	private javax.swing.JScrollPane scroll;
	private javax.swing.JPanel existingPanel;
	private javax.swing.JPanel buttonsPanel;
	private ArrayList projectDirectories = null;
	private String [] fileList = null;
	final public int OK = 1;
	final public int NEW = 2;
	final public int CANCEL = 0;
	public int exitStatus = -1;
	private JList projectList;
	private String selectedProject;
	
	public ProjectChooser() {
		super();
	}

	public String getSelectedProject() {
		// return the name of the project we selected
		return selectedProject;
	}

	public void getProjectData(File dir) {
		// get the list of folders from the "projects" folder in the directory passed as parameter
		try {
			String projectPath = dir.getCanonicalPath() + dir.separator + "projects";
			// System.out.println(projectPath);
			File projectsDir = new File(projectPath);
			// projectList = new JList();
			// projectList.setListData(projectsDir.listFiles());
			// for (int i = 0; i < projectsDir.listFiles().length; i++)
			// 	System.out.println(projectsDir.listFiles()[i]);

			// fileList = new File [projectsDir.listFiles().length];
			// System.arraycopy(projectsDir.listFiles(), 0, fileList, 0, projectsDir.listFiles().length);
			fileList = projectsDir.list();
			
		} catch (Exception e) {e.printStackTrace(System.err);}
		
	}

	private void initComponents() {
		projectList.setSelectedIndex(0);
		scroll = new JScrollPane(projectList);

		this.getContentPane().setLayout(new java.awt.BorderLayout());
                this.getContentPane().add(scroll,java.awt.BorderLayout.CENTER);

		javax.swing.JButton ok = new javax.swing.JButton("Open Project");
		javax.swing.JButton createnew = new javax.swing.JButton("Create New");
		javax.swing.JButton cancel = new javax.swing.JButton("Cancel");

		javax.swing.JPanel buttonsPanel = new javax.swing.JPanel();
		buttonsPanel.setLayout(new java.awt.FlowLayout());

		createnew.addActionListener(new java.awt.event.ActionListener(){
			public void actionPerformed(java.awt.event.ActionEvent e){
				newProject();
			}
		});
		ok.addActionListener(new java.awt.event.ActionListener(){
			public void actionPerformed(java.awt.event.ActionEvent e){
				if (projectList == null || projectList.getSelectedValue() == null)
					return;	// we can't really let the user click ok if there is nothing, let him go and do cancel
				exitStatus = OK;
				// fetch the name of the selection
				selectedProject = (String) projectList.getSelectedValue();
				dispose();
			}
		});

		cancel.addActionListener(new java.awt.event.ActionListener(){
			public void actionPerformed(java.awt.event.ActionEvent e){
				exitStatus = CANCEL;
				dispose();
			}
		});

		buttonsPanel.add(ok); buttonsPanel.add(createnew); buttonsPanel.add(cancel);

		this.getContentPane().add(buttonsPanel,java.awt.BorderLayout.SOUTH);

		this.setTitle("Choose a project or create new");
		this.pack();
	}

	public ProjectChooser(File workingDir) {
		super();
		selectedProject = null;

		getProjectData(workingDir);
		projectList = new JList();
		projectList.setListData(fileList);
		projectList.setSelectedIndex(0);

		initComponents();
	}

	private void newProject() {
		// open up a dialog to ask for the project name
		String s = (String)JOptionPane.showInputDialog(this, "Input the name of the new project:", "New Project",
			JOptionPane.PLAIN_MESSAGE, null, null, "New Project");

		if ((s != null) && (s.length() > 0)) {
			selectedProject = s;
			exitStatus = NEW;
			dispose();
		}
	}
}
