package jigcell.project;

/**
 * Indicates that an exception condition has occured while operating on a Project or ProjectFile.
 *
 * This code is licensed under the DARPA BioCOMP Open Source License.  See LICENSE for more details.
 *
 * @author Nicholas Allen
 */


public class ProjectException extends Exception {

   /**
    * Creates a new ProjectException with no additional information.
    */

   public ProjectException () {
      super ();
   }

   /**
    * Creates a new ProjectException with detail message.
    *
    * @param message Detail message for this exception (may be null)
    */

   public ProjectException (String message) {
      super (message);
   }

   /**
    * Creates a new ProjectException with cause.
    *
    * @param cause Cause of this exception (may be null)
    */

   public ProjectException (Throwable cause) {
      super (cause);
   }

   /**
    * Creates a new ProjectException with detail message and cause.
    *
    * @param message Detail message for this exception (may be null)
    * @param cause Cause of this exception (may be null)
    */

   public ProjectException (String message, Throwable cause) {
      super (message, cause);
   }
}
