package jigcell.project;

import java.io.File;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.ArrayList;
import javax.swing.*;
import javax.swing.filechooser.*;

// this contains the horrible hack to make the files show even though they have the ! and version
// after the name; it achieves this by simply creating temp files from all the files


public class ProjectFileFilter extends FileFilter {

	private Hashtable filters = null;
	private String description = null;
	private String fullDescription = null;
  	private ArrayList projectFiles = null; 
	private Project project = null; 

	public ProjectFileFilter(Project current) {
		this.project = current;
		this.filters = new Hashtable();
		try { 
			projectFiles = new ArrayList(current.getProjectFiles());
			File dir = new File(System.getProperty("user.dir"));
			String projectPath = dir.getCanonicalPath() + dir.separator + "projects" + dir.separator + current.getName();
			for (int i = 0; i < projectFiles.size(); i++) {
				ProjectFile currentFile = (ProjectFile) projectFiles.get(i);
				File tempFile = new File(projectPath + dir.separator + currentFile.getName());
				java.io.RandomAccessFile file = new java.io.RandomAccessFile(tempFile.getPath(),"rw");
				file.writeBytes((String)currentFile.load(null, currentFile.getVersion()));
				file.close();
				tempFile.deleteOnExit();
			}
		} catch (Exception e) {e.printStackTrace(System.err);}
	}

	public ProjectFileFilter(Project current, String[] filters, String description) {
		this(current);
		for (int i = 0; i < filters.length; i++)
			addMIMEType(filters[i]);
		if(description!=null) setDescription(description);
	}

	public boolean accept(File f) {
		try {
		if(f != null) {
			if(f.isDirectory()) {
				return false;
			}
			String name = f.getName();
			int look = 0; for (; look < projectFiles.size(); look++)
				if (((ProjectFile)projectFiles.get(look)).getName().compareTo(name) == 0) break;
			if (look >= projectFiles.size()) return false;
			ProjectFile current = (ProjectFile)projectFiles.get(look);
			String type = current.getMIMEType(current.getVersion());
			if(type != null && filters.get(type) != null) {
				return true;
			};
		}
		return false;
		} catch (Exception e) {e.printStackTrace(System.err); return false;}
	}

	public void addMIMEType(String type) {
		if(filters == null) {
			filters = new Hashtable(5);
		}
		filters.put(type, this);
		fullDescription = null;
	}


	public String getDescription() {
		if(fullDescription == null) {
			if(description == null) {
				fullDescription = description==null ? "(" : description + " (";
				// build the description from the extension list
				Enumeration extensions = filters.keys();
				if(extensions != null) {
					fullDescription += "." + (String) extensions.nextElement();
					while (extensions.hasMoreElements()) {
						fullDescription += ", " + (String) extensions.nextElement();
					}
				}
				fullDescription += ")";
			} else {
				fullDescription = description;
			}
		}
		return fullDescription;
	}

	public void setDescription(String description) {
		this.description = description;
		fullDescription = null;
	}
}
